--- ./tests/unicode2.sub.ORIGIN	2019-03-06 15:17:00 +0100
+++ ./tests/unicode2.sub	2019-03-06 15:17:12 +0100
@@ -13,7 +13,7 @@
 #
 . ./test-glue-functions
 
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 
 printf '%s\n' "$(printf '\uff')" | od -b | _intl_normalize_spaces
 printf '%s\n' $'\uff' | od -b | _intl_normalize_spaces
@@ -19,6 +19,6 @@
 
 LC_CTYPE=C printf '\uff'\\n | od -b | _intl_normalize_spaces
 LC_CTYPE=ru_RU.CP1251 printf '\uff'\\n | od -b | _intl_normalize_spaces
-LC_CTYPE=en_US.UTF-8 printf '\uff'\\n | od -b | _intl_normalize_spaces
+LC_CTYPE=EN_US.UTF-8 printf '\uff'\\n | od -b | _intl_normalize_spaces
 
 echo -e '\u0041 \u00a3 \u0152' | od -b | _intl_normalize_spaces
Index: bash-4.3.30/tests/intl.tests
===================================================================
--- bash-4.3.30.orig/tests/intl.tests	2015-08-05 10:31:33.000000000 +0200
+++ bash-4.3.30/tests/intl.tests	2015-08-05 11:28:25.000000000 +0200
@@ -11,7 +11,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
-export LC_ALL=en_US.UTF-8
+export LC_ALL=EN_US.UTF-8
 
 a=$'\303\251'
 
Index: bash-4.3.30/tests/intl1.sub
===================================================================
--- bash-4.3.30.orig/tests/intl1.sub	2015-08-05 10:33:34.000000000 +0200
+++ bash-4.3.30/tests/intl1.sub	2015-08-05 11:28:42.000000000 +0200
@@ -1,5 +1,5 @@
-LC_ALL=en_US.UTF-8
-LANG=en_US.UTF-8
+LC_ALL=EN_US.UTF-8
+LANG=EN_US.UTF-8
 
 var='абвгдежзиклмноп '
 echo -"$var"- ${#var}
Index: bash-4.3.30/tests/source5.sub
===================================================================
--- bash-4.3.30.orig/tests/source5.sub	2015-08-05 10:35:30.000000000 +0200
+++ bash-4.3.30/tests/source5.sub	2015-08-05 11:29:28.000000000 +0200
@@ -11,7 +11,7 @@
 #   You should have received a copy of the GNU General Public License
 #   along with this program.  If not, see <http://www.gnu.org/licenses/>.
 #
-LC_ALL=en_US.UTF-8
+LC_ALL=EN_US.UTF-8
 unset LC_ALL
 unset LANG
 export LC_ALL=C
Index: bash-4.3.30/tests/unicode1.sub
===================================================================
--- bash-4.3.30.orig/tests/unicode1.sub	2015-08-05 10:36:50.000000000 +0200
+++ bash-4.3.30/tests/unicode1.sub	2015-08-05 11:29:55.000000000 +0200
@@ -574,7 +574,7 @@
 
 
  )
-TestCodePage en_US.UTF-8 C_UTF_8
+TestCodePage EN_US.UTF-8 C_UTF_8
 
 if [ ${ErrorCnt} -gt 0 ]; then
   echo "Failed ${ErrorCnt} of ${TestCnt} Unicode tests"
--- ./tests/glob3.sub.orig	2020-09-14 15:40:51 +0200
+++ ./tests/glob3.sub	2020-09-14 15:41:14 +0200
@@ -65,7 +65,7 @@
 export LANG=C
 matchfunc
 
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 matchfunc
 
 unset -f matchfunc
@@ -116,7 +116,7 @@
 export LANG=C
 matchfunc
 
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 matchfunc
 
 unset -f matchfunc
@@ -156,7 +156,7 @@
 export LANG=C
 matchfunc
 
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 matchfunc
 
 cd $OLDPWD
--- ./tests/intl3.sub.orig	2020-09-14 15:42:39 +0200
+++ ./tests/intl3.sub	2020-09-14 15:43:13 +0200
@@ -14,7 +14,7 @@
 . ./test-glue-functions
 
 # more tests to make sure that IFS splits on characters, not bytes
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 
 euro=$'\342\202\254'
 o342=$'\342'
--- ./tests/glob.right.orig	2020-09-14 16:08:04 +0200
+++ ./tests/glob.right	2020-09-14 16:08:27 +0200
@@ -23,7 +23,7 @@
 ok 2.1
 ok 3
 ok 4
-== LANG=en_US.UTF-8 ==
+== LANG=EN_US.UTF-8 ==
 [[:alpha:]
 ok 1
 [a
@@ -42,7 +42,7 @@
 ok 4
 ok 5
 ok 6
-== LANG=en_US.UTF-8 ==
+== LANG=EN_US.UTF-8 ==
 p
 p
 ok 1
@@ -58,7 +58,7 @@
 ok 3
 ok 4
 ok 5
-== LANG=en_US.UTF-8 ==
+== LANG=EN_US.UTF-8 ==
 ok 1
 ok 2
 ok 3
--- ./tests/printf2.sub.orig	2023-06-21 01:08:00.002701100 +0000
+++ ./tests/printf2.sub	2023-06-21 01:08:12.036041714 +0000
@@ -6,7 +6,7 @@
 *)	echo "printf2.sub: character conversion failed" >&2  ;;
 esac
 
-export LANG=en_US.UTF-8
+export LANG=EN_US.UTF-8
 case $(printf %d\\n \'À) in
 192)	exit 0;;
 *)	echo "printf2.sub: multibyte character conversion failed" >&2 ; exit 2 ;;